package com.ynet.life.sujrb.file.parser;

import java.util.HashMap;
import java.util.Map;

public class RegexCreditCode {

   static String creditCode = "9132108434627958XC";
   static String isCreditCode = "true";
   static String error_CreditCode = "社会信用代码有误";
   static String error_CreditCode_min = "社会信用代码不足18位，请核对后再输！";
   static String error_CreditCode_max = "社会信用代码大于18位，请核对后再输！";
   static String error_CreditCode_empty = "社会信用代码不能为空！";
   private static Map datas = null;
   private static char[] pre17s;
   static int[] power = new int[]{1, 3, 9, 27, 19, 26, 16, 17, 20, 29, 25, 13, 8, 24, 10, 30, 28};
   static char[] code = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 'T', 'U', 'W', 'X', 'Y'};


   public static void main(String[] temp) {
      String temp1 = creditCode;
      initDatas(code.length);
      pre17(temp1);
      isCreditCode(temp1);
   }

   static boolean isCreditCode(String creditCode) {
      if(!"".equals(creditCode) && !" ".equals(creditCode)) {
         if(creditCode.length() < 18) {
            System.out.println(error_CreditCode_min);
            return false;
         } else if(creditCode.length() > 18) {
            System.out.println(error_CreditCode_max);
            return false;
         } else {
            int temp = (temp = sum(pre17s) % 31) == 0?31:temp;
            return (creditCode.substring(17, 18).equals(String.valueOf(code[31 - temp]))?isCreditCode:error_CreditCode) == "true";
         }
      } else {
         System.out.println(error_CreditCode_empty);
         return false;
      }
   }

   private static int sum(char[] chars) {
      int sum = 0;

      for(int i = 0; i < chars.length; ++i) {
         int code = ((Integer)datas.get(String.valueOf(chars[i]))).intValue();
         sum += power[i] * code;
      }

      return sum;
   }

   static void pre17(String creditCode) {
      pre17s = creditCode.substring(0, 17).toCharArray();
   }

   static void initDatas(int i) {
      datas = new HashMap();

      for(i = 0; i < code.length; ++i) {
         datas.put(String.valueOf(code[i]), Integer.valueOf(i));
      }

      System.out.println();
   }
}
